/***************************************************************/
/* Berechnung der Zahl pi = 3.1415926... auf Basis der Formel: */
/*							       */
/* pi	  4    1     1	4      1      1  4	1	       */
/* --- = (- - ---) - -(--- - -----) + -(--- - -----) - + ...   */
/*  4	  5   239    3 5^3   239^3    5 5^5   239^5	       */
/*							       */
/* von Reinhard Scharnagl, 4000 Duesseldorf, Feb.-April 1992,  */
/* unter der Benutzung von PureC, in der Version Feb 03 1992   */
/* (Tab = 8)						       */
/***************************************************************/

/* Anpassungen */

#ifdef __STDC__
#define _(parms) parms	 /* ANSI C version */
#include <stdlib.h>
#else
#define _(parms) ()	 /* old C version */
#define void /**/
#endif

#ifdef __TURBOC__
#pragma warn -use
#endif

/* eingebundene Help-Dateien */

#include <stdio.h>

/* lokale Prototypen */

void big_set _((unsigned *field, unsigned value,       int length));
int  big_div _((unsigned *field, unsigned divisor,     int length));
void big_add _((unsigned *field, unsigned *summand,    int length));
void big_mul _((unsigned *field, unsigned factor,      int length));
void big_out _((unsigned *field, int	  digits,      int length));
void big_cpy _((unsigned *field, unsigned *source,     int length));
void big_sub _((unsigned *field, unsigned *subtrahend, int length));

typedef unsigned BUFFER[6810*sizeof(unsigned)];

/***************************************************************/
/* Aufruf "CALC_PI.TTP nnn" mit 0 < nnn < 32768 Dezimalstellen */
/***************************************************************/

int main _((int ac, char **av));
int main(ac,av)
  int ac;
  char **av;
{ register unsigned divisor;
  register int huge;
  int digits, arg;
  unsigned *sum,		     /* langes Rechenfeld 1 */
	   *quo,		     /* langes Rechenfeld 2 */
	   *buf;		     /* langes Rechenfeld 3 */

 GetRam: {
  {
   if ((sum = (unsigned *)malloc(sizeof(BUFFER))) == 0L)  {
    goto aCGetRam;
   }{
    if ((quo = (unsigned *)malloc(sizeof(BUFFER))) == 0L)  {
     goto aCGetRam;
    }{
     if ((buf = (unsigned *)malloc(sizeof(BUFFER))) == 0L)  {
      aCGetRam:
      printf("Speicher reicht nicht!\n\n");
      return 1;
     }{
 }}}}}
  
 AskParm: {
  {
   if (ac < 2) {
    printf("gewuenschte Genauigkeit? ");
    scanf("%s", av[ac++] = (char *)sum);
    goto cBAskParm;
   }{
    cBAskParm:
    arg = 0;
 }}}

 DoActArg: {
  {
   if (++arg >= ac) {
    return 0;
   }{
 }}}

 ReadArg: {
  {
   if (sscanf(av[arg],"%d",&digits)) {
    if (digits <= 0) {
     goto aCReadArg;
    }{
   }} else {
    aCReadArg:
    printf("Eingabe fehlerhaft: %s\n\n", av[arg]); 
    goto DoActArg;
 }}}

 StartCalc: {
  {
  printf("Berechnung von pi mit %d Stellen:\n\n",digits);
    huge = (int)((digits*1000L)/(301L*8*sizeof(unsigned))+3);
    big_set(sum,     0, huge);
 }}

 DoCalcPh1: {
  big_set(quo, 4*4*5, huge); for (divisor = 1; ; divisor += 2)
  {
   if ( big_div(quo, 5*5, huge), big_cpy(buf, quo, huge),
  big_div(quo, divisor, huge)) {
    if (divisor & 2) {
     big_sub(sum, quo, huge);
     goto cBDoCalcPh1;
    }{
     big_add(sum, quo, huge);
     cBDoCalcPh1:
     big_cpy(quo, buf, huge);
   }} else {
    break;
 }}}

 DoCalcPh2: {
  big_set(quo, 4*239, huge); for (divisor = 1; ; divisor += 2)
  {
   if ( big_div(quo, 239*239, huge), big_cpy(buf,	quo, huge),
  big_div(quo, divisor, huge)) {
    if (divisor & 2) {
     big_add(sum, quo, huge);
     goto cBDoCalcPh2;
    }{
     big_sub(sum, quo, huge);
     cBDoCalcPh2:
     big_cpy(quo, buf, huge);
   }} else {
    break;
 }}}

 PrintNum: {
  {
  big_out(sum, digits, huge); goto DoActArg;
 }}
}

void big_set(field, value, length)
  register unsigned *field, value;
  register int length;
{ 
 BigSet: {
  *(field++) = value; for (;;)
  {
   if (--length) {
    *(field++) = 0;
   } else {
    break;
 }}}
}

void big_cpy(field, source, length)
  register unsigned *field, *source;
  register int length;
{ 
 BigCopy: {
  for (;;)
  {
   if (--length) {
    *(field++) = *(source++);
   } else {
    break;
 }}}
}

int big_div(field, divisor, length)
  unsigned *field;
  register unsigned divisor;
  int length;
{ register unsigned long accumulator;
  register unsigned *p_work, *p_bound;
  register int any_bits;

 BigDiv: {
  accumulator = 0L; any_bits = 0; p_work = field;
    p_bound = &p_work[length]; for (; ; ++p_work)
  {
   if (p_work < p_bound) {
    if ((accumulator += *p_work) != 0L) {
     if ((*p_work = (unsigned)(accumulator/divisor)) != 0)  {
      any_bits = 1;
      goto bBBigDiv;
     }{
      bBBigDiv:
      accumulator %= divisor; accumulator <<= (8*sizeof(unsigned));
    }} else {
   }} else {
    return any_bits;
 }}}
}

void big_add(field, summand, length)
  unsigned *field, *summand;
  int length;
{ register unsigned long accumulator;
  register unsigned *p_fld, *p_smd;

 BigAdd: {
  accumulator = 0L; p_fld = &field[length]; p_smd = &summand[length];
    for (;;)
  {
   if ((--p_smd, --p_fld) >= field) {
    accumulator >>= (8*sizeof(unsigned)); accumulator += *p_fld;
      accumulator += *p_smd; *p_fld = (unsigned)accumulator;
   } else {
    break;
 }}}
}

void big_sub(field, subtrahend, length)
  unsigned *field, *subtrahend;
  int length;
{ register unsigned long accumulator;
  register unsigned *p_fld, *p_std;

 BigAdd: {
  accumulator = 0L; p_fld = &field[length]; p_std = &subtrahend[length];
    for (;;)
  {
   if ((--p_std, --p_fld) >= field) {
    accumulator >>= (8*sizeof(unsigned)); accumulator += *p_fld;
      accumulator += ~*p_std; *p_fld = (unsigned)accumulator;
   } else {
    break;
 }}}
}

void big_mul(field, factor, length)
  unsigned *field, factor;
  int length;
{ register unsigned long accumulator, l_factor;
  register unsigned *p_work;

 BigMult: {
  accumulator = 0L; l_factor = factor; p_work = &field[length]; for (;;)
  {
   if (--p_work >= field) {
    accumulator >>= (8*sizeof(unsigned));
      accumulator += *p_work * l_factor; *p_work = (unsigned)accumulator;
   } else {
    break;
 }}}
}

void big_out(field, digits, length)
  register unsigned *field;
  register int digits, length;
{ register int count;

 BigOut: {
  for (count = 0, digits += (3-1); ; count += 3)
  {
   if (count < digits) {
    printf("%03u",field[0]);
      printf(!count ? "." : ((count+3) % (18*3)) ? " " : "\n");
      field[0] = 0; big_mul(field, 1000, length);
   } else {
    printf("\n\n");
    break;
 }}}
}
