/* ET-Beispiel-Hauptprogramm: (C) 1990/Jan/06 - 1991/Okt/16,    */
/*                             R. Scharnagl, 4000 Duesseldorf 1 */

  /*============================================================*/
  /* PRIM.T - Demonstrations-Hauptprogramm zur Benutzung von    */
  /* Entscheidungs-Tabellen (ETs) in C-Programmen mittels des   */
  /* Precompilers DTT.                                          */
  /*------------------------------------------------------------*/
  /* Eine ET hat hier formal das folgende Erscheinungsbild,     */
  /* (wobei eine evtl. ELSE-Spalte nur aus (.) besteht):        */
  /*                                                            */
  /* Start-Makro:       $TABLE <name>                           */
  /* Bedingungsmakro:   $C <cond.>      $ <flags (Y|N|.)> ...   */
  /*                       <cond.>      $ <flags (Y|N|.)> ...   */
  /*                       ...                                  */
  /* Aktionsmakro:      $A <statm.>     $ <flags (X|.)>   ...   */
  /*                       <statm.>     $ <flags (x|.)>   ...   */
  /*                       ...                                  */
  /* Ende-Makro:        $END                                    */
  /*                                                            */
  /* Es sind auch modifizierte ET-Formen moeglich. So duerfen   */
  /* zwischen $TABLE und $C eine Reihe von Anweisungen stehen   */
  /* (oder auch Schleifenkoepfe), die als gemeinsame Liste      */
  /* vorgeschalteter Aktionen aufgefasst wird. Die $C- und      */
  /* $A-Teile koennen auch gaenzlich fehlen, es liegt dann      */
  /* eine reine Aktionstabelle vor. Im $C-Teil kann das "if"    */
  /* des Bedingungsteils auch entfallen, es wird dann spaeter   */
  /* ergaenzt. Eine logische Zeile kann sich ueber mehrere      */
  /* physische Zeilen erstrecken. Innerhalb von ETs sind auch   */
  /* Kommentare, falls nicht mehrzeilig, erlaubt.               */
  /*------------------------------------------------------------*/
  /* DTT kann mit diversen Optionen aufgerufen werden:          */
  /*   -T  :  Trace generating (Zaehlung beim Programmlauf)     */
  /*   -C  :  Copy tables (ETs werden als Kommentar wiederholt) */
  /*   -S  :  Silent (alle Meldungen werden unterdrueckt)       */
  /*   -M  :  Mark ELSE usage (protokolliere ELSE-Benutztung)   */
  /*   -N  :  No ANSI standard (Fuer C-Compiler alten Typs)     */
  /*------------------------------------------------------------*/
  /* Im Trace-Mode wird mit dem zugelinkten Modul TRACE.O nach  */
  /* dem Programm-Ende eine Uebersicht aller angesprochenen und */
  /* mit der Trace-Option uebersetzten Module aufgelistet.      */
  /* Die Anzahl der Programmdurchlaeufe jeder Tabellenregel ist */
  /* darin ersichtlich. Nicht vollstaendig durchlaufene ETs     */
  /* werden mit '?' markiert, unberuehrte durch '*'. So laesst  */
  /* sich die Unvollstendigkeit einer Testumgebung bzw. uner-   */
  /* reichbarer Programmcode leichter erkennen und abaendern.   */
  /* Auch beim Test von GEM-Anwendungen ist durch ein (DT_TRACE */
  /* bedingt compiliertes) Umlenken von 'stdout' vor dem Pro-   */
  /* grammende eine Dokumentation von Dialoganwendungssitzungen */
  /* in aehnlicher Weise moeglich.                              */
  /*------------------------------------------------------------*/
  /* DTT verifiziert die Korrektheit der ETs, die Vollstaendig- */
  /* keit der Regeln und gibt entsprechende Hinweise aus.       */
  /*============================================================*/

#ifdef __STDC__
#include <stdlib.h>
#define _(parms) parms /* prototyp */
#else
#define void  /* */
#define const /* */
#define _(parms) ()    /* old declaration */
#endif

/* Benoetigte Copy-Bibliothek */
#include <stdio.h>

#ifdef __TURBOC__
#pragma warn -use
#endif

/* Prototypen */
void    Ausgabe         _((int i));
void    Outc            _((char c));
void    Vorbereitung    _((void)); 
void    Hauptteil       _((void));
int     main            _((void));

/* Globale Variablen */
int     test, teil, quot, zaehler, anzahl;

int main()             /*=======================================*/
{                      /* Berechnung der ersten N.N. Primzahlen */
                       /*=======================================*/

 Steuerung: {
  {
  Vorbereitung(); Hauptteil(); return 0;
 }}
}

void Vorbereitung()    /*=======================================*/
{                      /* Einmalige Vorbereitungen durchfuehren */
                       /*=======================================*/

 Titelzeile: {
  {
  Ausgabe(anzahl = 260); puts(" PRIMZAHLEN:");
 }}

 Grundwert: {
  {
   if (test == 0) {
    test = 1;
    zaehler = 0;
   } else {
 }}}
}

void Hauptteil()                /*==============================*/
{                               /* Eigentlicher Primzahl-Zyklus */
                                /*==============================*/

 neue_Zahl: {
  {
   if (test > 2) {
    test += 2;
    goto cAneue_Zahl;
   }{
    test += 1;
    cAneue_Zahl:
    teil = 1;
 }}}

 neuer_Test: {
  teil += 1; quot = test / teil;
  {
   if (quot < teil) {
   } else {
    if (quot * teil == test) {
     goto neue_Zahl;
    }{
     goto neuer_Test;
 }}}}

 Primzahl: {
  zaehler += 1; Ausgabe(test);
  {
   if (zaehler < anzahl) {
    if (zaehler % 13) {
     goto neue_Zahl;
   }} else {
    Outc('\n');
    return;
   }
   Outc('\n');
   goto neue_Zahl;
 }}

 Unsinn: {
  {
  return;
 }}
}

