/* ET-Tracing-Package: (C) 1990/Jan/06 - 1991/Okt/24,           */
/*                      R. Scharnagl, 4000 Duesseldorf 1        */

/* Changes: 90/Jan/06: new flag symbols, DT-form                */
/*          90/Jun/24: converted program to ANSI-standard       */
/*          91/Oct/20: general review and optimization started  */
/*	    92/Mar/14: Umstellung auf mit Lattice-C 5.5		*/	     

#define  M_ROW 100  /* max. Anzahl Tabellen */
#define  M_CNT   8  /* max. Zaehlpositionen */
#define  M_NME  14  /* max. Namenlaenge */
#define  M_DIG   8  /* max. Platz je Zahl */

#ifdef __STDC__
#include <stdlib.h>
#define _(parms) parms /* prototyp */
#else
#define void  /* */
#define const /* */
#define _(parms) ()    /* old declaration */
#endif

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#ifdef MEGAMAX
#define size_t  int
#define atexit  onexit
#endif

#ifdef __TURBOC__
#pragma warn -use
#endif

typedef struct trace {
  int flg; 
  long *trc;
  struct trace *t; 
  const char *str[100];
} TRACE;

static TRACE *trace = NULL;

/* Prototypen */
static void Oc    _((char c));
static void Orep  _((char c, int i));
static void Oline _((void)); 
static void Od    _((long m, int c));
       void __rpt _((void)); 
       void __rgs _((int *id)); 

static void Oc(c)                     /*========================*/
  char c; {                           /* Ausgabe eines Zeichens */
                                      /*========================*/
 ZeichAusgabe: {
  {
  putchar((int)c);
 }}
}

static void Orep(c,i)              /*===========================*/
  char c; int i; {                 /* Wiederholte Ausgabe eines */
                                   /* Zeichens nach stdout.     */
                                   /*===========================*/
 MultiAusgabe: {
  {
  while (--i >= 0) Oc(c);
 }}
}

static void Oline() {               /*==========================*/
                                    /* Ausgabe einer Trennlinie */
                                    /*==========================*/
 TrLnAusgabe: {
  {
  Orep('-',M_DIG*M_CNT+M_NME+1); Oc('\n');
 }}
}

static void Od(m,c)		/*==============================*/
  long m; int c; {		/* Ausgabe einer l. Dezimalzahl */
  register int k, i;		/* auf vorgegebener Stellenzahl */
  register char *p;		/*==============================*/
  char dig[16];

 DzVorbereitung: {
  {
  (p = dig)[i = 15] = '*';
 }}

 DzModBildung: {
  {
  do p[--i] = '0'+(char)(m % 10); while ((m /= 10) != 0L);
 }}

 DzZahlTyp: {
  {
   if ((k = c+i-15) <= 0) {
    p[15-1+k] = '*';
    p[15-2+k] = '3'-(char)(k);
    p[15-3+k] = 'e';
    k = 1;
    goto eBDzZahlTyp;
   }{
    eBDzZahlTyp:
    Orep(' ',k);
 }}}

 DzZiffAusgabe: {
  {
  do Oc(p[i]); while (p[++i] != '*');
 }}
}

void __rpt() {                      /*==========================*/
  register int i, j, k, m;          /* Tabellen-Nutzungs Report */
  register long *r;                 /*==========================*/
  register const char *s;
  register TRACE *work;
  register FILE *f;

 RpInitial: {
  {
  work = trace; f = stdout;
 }}

 RpNxtModul: {
  {
   if (work) {
    Oc('\n');
   } else {
    return;
 }}}
   
 RpSuchNModul: {
  for (j = i = 0; ;++j)
  {
   if (s = work->str[j], isupper(*s)) {
    if (*s > (char)i) {
     i = (int)*s;
    } else {
   }} else {
    fputs(s,f);
    Orep(' ',M_NME-(int)strlen(s));
    fputs("#",f);
    j = 0;
    r = work->trc;
    break;
 }}}

 RpTitelRechts: {
  for (k = (int)'A'-1; ;)
  {
   if (++k == i) {
    Orep(' ',M_DIG-1);
    goto eBRpTitelRechts;
   }{
    if (k >= (int)'A'-1+M_CNT) {
     Orep(' ',M_DIG-3);
     Oc((char)k);
     Oc('-');
     eBRpTitelRechts:
     Oc((char)i);
     Oc('\n');
     Oline();
     k = 0;
     break;
    }{
     Orep(' ',M_DIG-1);
     Oc((char)k);
 }}}}

 RpNxtTabelle: {
  r += k; k = (int)*(s = work->str[j++]);
  {
   if (isupper(k)) {
    k -= (int)'A'-1;
    fputs(++s,f);
    Orep(' ',M_NME-(int)strlen(s));
   } else {
    Oline();
    work = work->t;
    goto RpNxtModul;
 }}}

 RpBenZaehle: {
  for (i = m = 0; ;++i)
  {
   if (i < k) {
    if (r[i]) {
     if (i >= M_CNT) {
      r[M_CNT-1] += r[i];
      goto bBRpBenZaehle;
     }{
      bBRpBenZaehle:
      ++m;
    }} else {
   }} else {
    break;
 }}}
  
 RpFlgAusgabe: {
  {
   if (m) {
    if (m == k) {
     i = (int)'.';
     goto dCRpFlgAusgabe;
    }{
     i = (int)'?';
     goto dCRpFlgAusgabe;
   }}{
    i = (int)'*';
    dCRpFlgAusgabe:
    Oc((char)i);
 }}}

 RpZeiZaehle: {
  for (i = 0; ; )
  {
   if (i >= M_CNT || i >= k) {
    Oc('\n');
    goto RpNxtTabelle;
   }{
    Od(r[i++],M_DIG);
 }}}
}

void __rgs(id)                 /*===============================*/
  register int *id; {          /* Registrierung einer benutzten */
  register TRACE *work;        /* Tabellen-Liste (Modul)        */
                               /*===============================*/
 RgKennung: {
  ++*id;
  {
   if ((work = trace) == NULL) {
    trace = (TRACE *)id;
    atexit(__rpt);
    return;
   }{
 }}}

 RgVernetzung: {
  for (; ;work = work->t)
  {
   if (!work->t) {
    work->t = (TRACE *)id;
    return;
   }{
 }}}
}
