/* ET-Tracing-Package: (C) 1990/Jan/06 - 1991/Okt/24,           */
/*                      R. Scharnagl, 4000 Duesseldorf 1        */

/* Changes: 90/Jan/06: new flag symbols, DT-form                */
/*          90/Jun/24: converted program to ANSI-standard       */
/*          91/Oct/20: general review and optimization started  */
/*	    92/Mar/14: Umstellung auf mit Lattice-C 5.5		*/	     

#define  M_ROW 100  /* max. Anzahl Tabellen */
#define  M_CNT   8  /* max. Zaehlpositionen */
#define  M_NME  14  /* max. Namenlaenge */
#define  M_DIG   8  /* max. Platz je Zahl */

#ifdef __STDC__
#include <stdlib.h>
#define _(parms) parms /* prototyp */
#else
#define void  /* */
#define const /* */
#define _(parms) ()    /* old declaration */
#endif

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#ifdef MEGAMAX
#define size_t  int
#define atexit  onexit
#endif

#ifdef __TURBOC__
#pragma warn -use
#endif

typedef struct trace {
  int flg; 
  long *trc;
  struct trace *t; 
  const char *str[100];
} TRACE;

static TRACE *trace = NULL;

/* Prototypen */
static void Oc    _((char c));
static void Orep  _((char c, int i));
static void Oline _((void)); 
static void Od    _((long m, int c));
       void __rpt _((void)); 
       void __rgs _((int *id)); 

static void Oc(c)                     /*========================*/
  char c; {                           /* Ausgabe eines Zeichens */
                                      /*========================*/
  $TABLE ZeichAusgabe
  /*------------------------------------------------------------*/
     putchar((int)c);            /* Ausgabe Zeichen nach stdout */
  $END
}

static void Orep(c,i)              /*===========================*/
  char c; int i; {                 /* Wiederholte Ausgabe eines */
                                   /* Zeichens nach stdout.     */
                                   /*===========================*/
  $TABLE MultiAusgabe
  /*------------------------------------------------------------*/
     while (--i >= 0)               /* zaehle, ob noch zu tun ? */
       Oc(c);                                       /* ausgeben */
  $END
}

static void Oline() {               /*==========================*/
                                    /* Ausgabe einer Trennlinie */
                                    /*==========================*/
  $TABLE TrLnAusgabe
  /*------------------------------------------------------------*/
     Orep('-',M_DIG*M_CNT+M_NME+1);          /* Trenn-Linie und */
     Oc('\n');                          /* Zeilen-Ende ausgeben */
  $END
}

static void Od(m,c)		/*==============================*/
  long m; int c; {		/* Ausgabe einer l. Dezimalzahl */
  register int k, i;		/* auf vorgegebener Stellenzahl */
  register char *p;		/*==============================*/
  char dig[16];

  $TABLE DzVorbereitung
  /*------------------------------------------------------------*/
     (p = dig)[i = 15] = '*';      /* initial. Stopp-Ziffer '*' */
  $END

  $TABLE DzModBildung
  /*------------------------------------------------------------*/
     do p[--i] = '0'+(char)(m % 10);    /* def. naechste Ziffer */
     while ((m /= 10) != 0L);      /* solange weitere Stellen ? */
  $END

  $TABLE DzZahlTyp
  /*------------------------------------------------------------*/
  $C ((k = c+i-15) <= 0)       /* Exponent-Darstellung noetig ? */  $ Y N
  $A p[15-1+k] = '*';                  /* versetze Stopp-Ziffer */  $ X .
     p[15-2+k] = '3'-(char)(k);                /* ermittle Exp. */  $ X .
     p[15-3+k] = 'e';                  /* setze 'e' Trenn-Marke */  $ X .
     k = 1;                           /* logisches abdividieren */  $ X .
     Orep(' ',k);             /* fuehrende Leerzeichen Ausgeben */  $ X X
  $END

  $TABLE DzZiffAusgabe
  /*------------------------------------------------------------*/
     do Oc(p[i]);                             /* gib Ziffer aus */
     while (p[++i] != '*');       /* solange Puffer noch voll ? */
  $END
}

void __rpt() {                      /*==========================*/
  register int i, j, k, m;          /* Tabellen-Nutzungs Report */
  register long *r;                 /*==========================*/
  register const char *s;
  register TRACE *work;
  register FILE *f;

  $TABLE RpInitial
  /*------------------------------------------------------------*/
     work = trace;                     /* initial. Trace-Zeiger */
     f = stdout;                         /* setze Output-Zeiger */
  $END

  $TABLE RpNxtModul
  /*------------------------------------------------------------*/
  $C (work)                  /* vor einer neuen Modul-Tabelle ? */  $ Y N
  $A Oc('\n');               /* Abstand halten durch neue Zeile */  $ X .
     return;                        /* Ende der Tabellenausgabe */  $ . X
  $END
   
  $TABLE RpSuchNModul
  /*------------------------------------------------------------*/
     for (j = i = 0; ;++j)       /* init. String-Index und Max. */
  $C (s = work->str[j], isupper(*s))       /* Zaehl-Buchstabe ? */  $ Y Y N
     (*s > (char)i)                                /* maximal ? */  $ Y N .
  $A i = (int)*s;                                    /* Maximum */  $ X . .
     fputs(s,f);                        /* Modul-Namen ausgeben */  $ . . X
     Orep(' ',M_NME-(int)strlen(s));              /* tabulieren */  $ . . X
     fputs("#",f);                 /* Flag-Spalten-Ueberschrift */  $ . . X
     j = 0;               /* zeige wieder zum 1. Tabellen-Namen */  $ . . X
     r = work->trc;       /* zeige auf die assoziierten Zaehler */  $ . . X
     break;                            /* alle Strings geprueft */  $ . . X
  $END

  $TABLE RpTitelRechts
  /*------------------------------------------------------------*/
     for (k = (int)'A'-1; ;)       /* initial. Zaehl-Buchstaben */
  $C (++k == i)                                    /* Maximum ? */  $ N N Y
     (k >= (int)'A'-1+M_CNT)             /* letzter Buchstabe ? */  $ N Y .
  $A Orep(' ',M_DIG-1);                       /* tabuliere lang */  $ X . X
     Orep(' ',M_DIG-3);                       /* tabuliere kurz */  $ . X .
     Oc((char)k);                         /* gib Buchstaben aus */  $ X X .
     Oc('-');                                /* Bereichs-Strich */  $ . X .
     Oc((char)i);                   /* Bereichs-Ende-Buchstaben */  $ . X X
     Oc('\n');                                  /* beende Zeile */  $ . X X
     Oline();                             /* gib Trennlinie aus */  $ . X X
     k = 0;                             /* loesche Regelzaehler */  $ . X X
     break;                          /* alle Buchstaben gesetzt */  $ . X X
  $END

  $TABLE RpNxtTabelle
  /*------------------------------------------------------------*/
     r += k;        /* addiere alte Anzahl Regeln -> Startindex */
     k = (int)*(s = work->str[j++]);         /* Zaehl-Buchstabe */
  $C (isupper(k))                            /* Tabellen-Name ? */  $ Y N
  $A k -= (int)'A'-1;                     /* neue Anzahl Regeln */  $ X .
     fputs(++s,f);                    /* gib Tabellen-Namen aus */  $ X .
     Orep(' ',M_NME-(int)strlen(s));               /* tabuliere */  $ X .
     Oline();                             /* gib Trennlinie aus */  $ . X
     work = work->t;              /* weiter zum naechsten Modul */  $ . X  
     goto RpNxtModul;                 /* zu dessen Verarbeitung */  $ . X
  $END

  $TABLE RpBenZaehle
  /*------------------------------------------------------------*/
     for (i = m = 0; ;++i)       /* Index-Schleife, Merker klar */
  $C (i < k)                            /* gehoert Regel dazu ? */  $ Y Y Y N
     (r[i])                                  /* Regel benutzt ? */  $ Y Y N .
     (i >= M_CNT)                        /* ueber Regel-Limit ? */  $ Y N . .
  $A r[M_CNT-1] += r[i];       /* akkumuliere in letzter Spalte */  $ X . . .
     ++m;                                   /* zaehle Benutzung */  $ X X . .
     break;                         /* alle Regeln abgearbeitet */  $ . . . X
  $END
  
  $TABLE RpFlgAusgabe
  /*------------------------------------------------------------*/
  $C (m)                        /* Tabelle ueberhaupt benutzt ? */  $ Y Y N
     (m == k)                         /* vollstaendig benutzt ? */  $ Y N .
  $A i = (int)'.';                              /* OK! - Symbol */  $ X . .
     i = (int)'?';                          /* Pruefe! - Symbol */  $ . X .
     i = (int)'*';                     /* Fehler-Stern - Symbol */  $ . . X
     Oc((char)i);                            /* Symbol ausgeben */  $ X X X
  $END

  $TABLE RpZeiZaehle
  /*------------------------------------------------------------*/
     for (i = 0; ; )       /* Loesche Regel-Zaehler und beginne */
  $C (i >= M_CNT || i >= k)          /* keine zul. Regel mehr ? */  $ N Y
  $A Od(r[i++],M_DIG);                  /* Ausgabe des Zaehlers */  $ X .
     Oc('\n');                      /* beende Zeile, und weiter */  $ . X
     goto RpNxtTabelle;  /* fertig, naechste Tabelle bearbeiten */  $ . X
  $END
}

void __rgs(id)                 /*===============================*/
  register int *id; {          /* Registrierung einer benutzten */
  register TRACE *work;        /* Tabellen-Liste (Modul)        */
                               /*===============================*/
  $TABLE RgKennung
  /*------------------------------------------------------------*/
     ++*id;           /* vermerke Registrierung im Modul selbst */
  $C ((work = trace) == NULL)  /* noch kein Modul registriert ? */  $ Y N
  $A trace = (TRACE *)id;  /* pflanze Wurzel verketteter Module */  $ X .
     atexit(__rpt);  /* merke den Tabellen-Report fuer exit vor */  $ X .
     return;                                      /* damit Ende */  $ X .
  $END

  $TABLE RgVernetzung
  /*------------------------------------------------------------*/
     for (; ;work = work->t)                /* Kette abarbeiten */
  $C (!work->t)                     /* am Ende der Verkettung ? */  $ Y N
  $A work->t = (TRACE *)id;                /* am Ende eintragen */  $ X .
     return;                         /* Ende der Kette erreicht */  $ X .
  $END
}
